/*
Oryginalny kod: Piotr Pawluczuk / piopawlu.prv.pl
Zmiany od wersji 1.1: Rafa Lindemann / www.stamina.eu.org
*/

#include "stdafx.h"


VOID CALLBACK sConnection_base::MakeWindowAPC(sConnection_base * c) {
	IMDEBUG(DBG_FUNC , "[%x] MakeWindowAPC" , c);
	c->wnd = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TRANSFER), GetParent((HWND)UIGroupHandle(sUIAction(0,IMIG_MAINWND))) ,(DLGPROC)DlgProc,(LPARAM)c);
}
VOID CALLBACK sConnection_base::DestroyWindowAPC(sConnection_base * c) {
	if (!c->wnd) return;
	DestroyWindow(c->wnd);
	c->wnd = 0;
}


void sConnection_base::MakeWindow() {
	if (!wnd) {// moemy mie ju dopite okno!
		IMDEBUG(DBG_FUNC , "[%x] QueueMakeWindow" , this);
		QueueUserAPC((PAPCFUNC)MakeWindowAPC , hMainThread , (ULONG_PTR)this);
		while (!wnd && !flags.closed && !flags.canceled) {
			SleepEx(10,true);
			Ctrl->WMProcess();
		}
		SendMessage(GetDlgItem(wnd , IDC_CLOSE) , BM_SETCHECK , GETINT((operation == eoSending) ? Cfg::closeWindowUp : Cfg::closeWindowDown) ? BST_CHECKED : BST_UNCHECKED , 0);
	}
}
void sConnection_base::SetStatus(const char * msg) {
	IMLOG("[%x] Status = \"%s\"" , this , msg);
	if (!wnd) return;
	SetDlgItemText(wnd , IDC_STATUS , msg);
}


void sConnection_base::Stage(enStage stage) { // Wywoane w odpowiednim stadium poczenia
	IMLOG("[%x] Stadium %d -> %d / %d" , this , this->stage , stage , esFinished);
	this->stage = stage;
	if (!wnd) return;
	if (stage==esCreated) {
		::ShowWindow(GetDlgItem(wnd , IDB_OPEN) , SW_HIDE);
		::ShowWindow(GetDlgItem(wnd , IDB_OPENDIR) , SW_HIDE);
		::ShowWindow(GetDlgItem(wnd , IDB_SAVEAS) , SW_HIDE);
		::ShowWindow(GetDlgItem(wnd , IDRETRY) , SW_HIDE);
		SetDlgItemText(wnd , IDC_INFO , "");
		SetDlgItemText(wnd , IDC_STATUS , "");
		SetDlgItemText(wnd , IDOK , "Anuluj");
		SendDlgItemMessage(wnd , IDC_PROGRESS1 , PBM_SETPOS , 0 , 0);
	}
}

void sConnection_base::ShowWindow(bool foreground) {
	::ShowWindow(this->wnd , foreground ? SW_SHOWNOACTIVATE :  SW_SHOW);
	if (foreground) {
		SetForegroundWindow(this->wnd);
		SetActiveWindow(this->wnd);
	}
}

void sConnection::ShowWindow(bool foreground) {
	sConnection_base::ShowWindow(foreground);
	if (notifyID) {
		IMessage(KNotify::IM::hide , KNotify::net , IMT_ALL , notifyID);
		notifyID = 0;
	}
	if (foreground && msgID)
		msgID = 0; // Najpewniej ju zosta usunity...
}

void sConnection::Stage(enStage stage) { // Wywoane w odpowiednim stadium poczenia
//	if (flags.canceled) return; // nic tu po nas...
	enStage lastStage = this->stage;
	sConnection_base::Stage(stage);	
	if (!wnd && this->direction == edIncoming && this->operation != eoSending) { 
		if (stage < esConnected && !GETINT(Cfg::showOnConnection)) {
			return; // nie ma co robi jeszcze...
		}
	}
	bool show = (this->operation != eoReceiving && !this->msgID);

	// Skoro nie ma przeciwskaza - tworzymy okno...
	MakeWindow();
	// Ustawiamy przyciski
	// wypeniamy treci...

	
	SetDlgItemText(wnd , IDC_FILE , this->filename.c_str());
	SetDlgItemText(wnd , IDC_CLIENT , this->cntID > 0 ? GETCNTC(this->cntID , CNT_DISPLAY) : "Nieznany");
	// Czycimy okno... na wypadek gdyby jedno byo uywane przez kilka instancji...
	if (stage == esConnecting) {
		SetWindowTitle();
	} else if (stage == esNegotiating) {
		if (operation == eoReceiving) {
			kSound::SoundPlay(Ctrl , "fileReceived" , cntID);
			if (GETINT(Cfg::asMessage)) {
				// wstawiamy wiadomo do kolejki
				cMessage m;
				m.action = sUIAction(IMIG_CNT , Act::receiveFile , this->cntID);
				m.notify = UIIcon(IT_MESSAGE , NET_NONE , MT_FILE , 0);
				m.body = (char*)filename.c_str();
				char extbuff [200];
				sprintf(extbuff , EXT_PARAM "KT_HWND_TO_OPEN=%d" , this->wnd);
				m.ext = extbuff;
				m.flag = MF_NOSAVE;
				char uidbuff [200];
				m.fromUid = (char*)GETCNTC(this->cntID , CNT_UID , uidbuff , 200);
				m.net = GETCNTI(this->cntID , CNT_NET);
				m.time = time(0);
				m.type = MT_FILE;
				sMESSAGESELECT ms;
				ms.id = ICMessage(IMC_NEWMESSAGE , (int)&m);
				if (ms.id > 0) {
					ICMessage(IMC_MESSAGEQUEUE , (int)&ms);
					msgID = ms.id;
				}
				if (GETINT(KNotify::Cfg::msg)) {
					char tbuff [100];
					string file = this->filename.substr(this->filename.find('\\')+1);
					sprintf(tbuff , "Plik '%.40s' od: \"%.40s\"" , file.c_str() , GETCNTC(this->cntID , CNT_DISPLAY));
					KNotify::sIMessage_notify_kinfo n(tbuff, UIIcon(IT_MESSAGE , 0 , MT_FILE , 0), KNotify::sIMessage_notify::tInform , 20);
					n._clickable = 1;
					n._action = sUIAction(IMIG_CNT , Act::receiveFile , this->cntID);
					string ext = SetExtParam("", "file", this->filename);
					ext = SetExtParam(ext , "name" , GETCNTC(this->cntID , CNT_DISPLAY));
					n._infoArgs = (char*)ext.c_str();
					n._infoType = KNotify::sIMessage_notify_kinfo::tiFile;
					this->notifyID = Ctrl->IMessage(&n);
					

				}
			} else show = true;
		} else show = true; // dobry moment, eby w kocu go pokaza...
	} else if (stage == esOperating) {
		this->UpdateInfo();
		bool extended = (operation == eoReceiving);
		EnableWindow(GetDlgItem(wnd , IDB_OPEN) , false);
		EnableWindow(GetDlgItem(wnd , IDB_OPENDIR) , false);
		EnableWindow(GetDlgItem(wnd , IDB_SAVEAS) , false);
		::ShowWindow(GetDlgItem(wnd , IDB_OPEN) , extended? SW_SHOWNOACTIVATE : SW_HIDE);
		::ShowWindow(GetDlgItem(wnd , IDB_OPENDIR) , extended? SW_SHOWNOACTIVATE : SW_HIDE);
		::ShowWindow(GetDlgItem(wnd , IDB_SAVEAS) , extended? SW_SHOWNOACTIVATE : SW_HIDE);
		SetWindowTitle();
		SendDlgItemMessage(wnd , IDC_PROGRESS1 , PBM_SETRANGE32 , 0 , this->total);
		startTime = time(0);
	} else if (stage == esCancel) {
		SetStatus("Poczekaj, anuluj");
		EnableWindow(GetDlgItem(wnd , IDOK) , false);
	} else if (stage == esFailure) {
		if (file) {CloseHandle(file); file = 0;}
	} else if (stage == esSuccess) {
		UpdateInfo();
		EnableWindow(GetDlgItem(wnd , IDB_OPEN) , true);
		EnableWindow(GetDlgItem(wnd , IDB_OPENDIR) , true);
		EnableWindow(GetDlgItem(wnd , IDB_SAVEAS) , true);

		kSound::SoundPlay(Ctrl , "fileFinished" , cntID);

		flags.success = 1;
		if (Cfg::notifyOnCompletion)
			KTMessage("Przesyanie zostao zakoczone pomylnie\n"+this->filename);

	} else if (stage == esFinished) {
		SetDlgItemText(wnd , IDOK , "OK");
		if (!flags.success && this->operation == eoSending && this->direction == edOutgoing) {
			::ShowWindow(GetDlgItem(wnd , IDRETRY) , SW_SHOWNOACTIVATE);
		}
	}

	if (show && !IsWindowVisible(wnd))
		this->ShowWindow(false);
// Obsuga zamykania
	if (stage == esFinished) {
		SetWindowTitle();
		bool close = SendMessage(GetDlgItem(wnd , IDC_CLOSE) , BM_GETCHECK , 0 , 0) == BST_CHECKED;
		// Gdy wystpi bd, albo gdy nie zamykamy, czekamy na reakcj usera...
		// gdy wystpi bd czekamy zawsze...
		if (wnd && (this->msgID || IsWindowVisible(wnd)) && (!next || !flags.success) && !flags.canceled && (lastStage != esSuccess || !close)) {
			while (!this->flags.closed) {
				SleepEx(500 , true);
			}
		}
		// mogo si przestawi...
		close = SendMessage(GetDlgItem(wnd , IDC_CLOSE) , BM_GETCHECK , 0 , 0) == BST_CHECKED;
		SETINT((operation == eoSending) ? Cfg::closeWindowUp : Cfg::closeWindowDown  , close ? 1 :0);
		DropToHistory(lastStage);
	}

}
void sConnection_request::Stage(enStage stage) {
	sConnection_base::Stage(stage);	
    if (stage == esWaiting) {
		::ShowWindow(wnd , SW_SHOW);
	}
}

void sConnection::UpdateInfo(double transfer) {
	if (!wnd) return;
	if (transfer>=0 && GetTickCount() - lastUpdate < 200) return;
	if (transfer < 0) transfer = 0;
	lastUpdate = GetTickCount();
	SetWindowTitle();
	SendDlgItemMessage(wnd , IDC_PROGRESS1 , PBM_SETPOS , this->done, 0 );
	char buff [250];
	double globTransfer = ((float) this->transfered / max(1,time(0) - startTime));
	if (transfer == 0) transfer = globTransfer;
	int eta_s = (this->total - this->done) / globTransfer;
	int eta_m = eta_s / 60;
	eta_s %= 60;
	int scale = this->total > 10239000 ? 1024*1024 : 1024;
	_snprintf(buff , 250 , "%4.0f z %4.0f %s \t %3.1f KB/s \t ETA: %2dm %2ds" , floor(this->done/scale) , ceil(this->total/scale) , (scale>1024?"M":"K") ,  transfer / 1024.0 , eta_m , eta_s);	
	SetDlgItemText(wnd , IDC_INFO , buff);
}
void sConnection_base::SetWindowTitle() {
	if (!wnd) return;
	SetWindowText(this->wnd , ("kT: " + this->filename).c_str());
}
void sConnection::SetWindowTitle() {
	if (!wnd) return;
	char buff [300], ext[50];
	char * dir = operation == eoSending ? ">" : operation == eoReceiving ? "<" : ":";
	char * file = !strrchr(this->filename.c_str() , '\\') ? "??" : strrchr(this->filename.c_str() , '\\')+1;
	int nextCount = this->CountNext();
	ext[0]=0;
	if (nextCount) {
		_snprintf(ext, 20, " jeszcze %d zada", nextCount);
	}
	if (startTime)
		_snprintf(buff , 200 , "kT%s %s [%d%%@%.2fKB/s]%s" , dir , file , done*100/total , (float)transfered / 1024 / (max(1,time(0) - startTime)), ext);
	else
		_snprintf(buff , 200 , "kT%s %s%s" , dir , file, ext);
	SetWindowText(this->wnd , buff);
}




void sConnection::DropToHistory(enStage lastStage) {
	if (GETINT(Cfg::saveToHistory)) {
		IMLOG("Zapisuj do historii");
		sHISTORYADD ha;
		cMessage m;
		bool sending = operation == eoSending;
		m.flag = (sending ? MF_SEND : 0);
		m.type = MT_FILE;
		m.net = GETCNTI(cntID , CNT_NET);
		m.time = _time64(0);
		char buffUid [200];
		if (sending)
			m.toUid = (char*)GETCNTC(cntID , CNT_UID , buffUid , 200);
		else
			m.fromUid = (char*)GETCNTC(cntID , CNT_UID , buffUid , 200);
		
		string body;
		string ext;
		ext = SetExtParam(ext , MEX_DISPLAY , GETCNTC(cntID , CNT_DISPLAY));
		ext = SetExtParam(ext , MEX_FILE_PATH , this->filename);
		ext = SetExtParam(ext , MEX_TITLE , this->filename.substr(this->filename.find_last_of('\\')+1));
		char buff [1024];
		ext = SetExtParam(ext , MEX_FILE_SIZE , itoa(this->total , buff , 10));
		ext = SetExtParam(ext , MEX_FILE_TRANSFER_TIME , itoa(time(0) - this->startTime , buff , 10));
		ext = SetExtParam(ext , MEX_FILE_TRANSFERED , itoa(this->transfered , buff , 10));
		if (lastStage!=esCancel && lastStage!=esSuccess) {
			if (wnd) {
				string error;
				GetDlgItemText(wnd , IDC_STATUS , buff , 1024);
				error+=buff;
				GetDlgItemText(wnd , IDC_INFO , buff , 1024);
				error+="\n";
				error+=buff;
				ext = SetExtParam(ext , MEX_FILE_ERROR , error);
			}
		}
		m.body = (char*)body.c_str();
		m.ext = (char*)ext.c_str();
		ha.m = &m;
		ha.dir = "kTransfer";
		ha.name = ((lastStage==esSuccess)? (sending?"Wysane":"Odebrane") : (flags.canceled)?"Anulowane":"Zerwane");
		ICMessage(IMI_HISTORY_ADD , (int)&ha);
	}
}


BOOL WINAPI sConnection_base::DlgProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message)
	{
	case WM_INITDIALOG: {
		SetProp(hwnd , "sConn*" , (HANDLE)lParam);
		SendMessage(hwnd , WM_SETICON , ICON_SMALL , ICMessage(IMI_ICONGET , UIIcon(IT_MESSAGE , 0 , MT_FILE , 0) , IML_16));
		int bigIco = ICMessage(IMI_ICONGET , UIIcon(IT_MESSAGE , 0 , MT_FILE , 0) , IML_32);
		if (bigIco)
			SendMessage(hwnd , WM_SETICON , ICON_BIG , bigIco);

		return TRUE;}
	case WM_DESTROY: {
		DestroyIcon((HICON)SendMessage(hwnd , WM_GETICON , ICON_SMALL , 0));
		DestroyIcon((HICON)SendMessage(hwnd , WM_GETICON , ICON_BIG , 0));
		return 1;}
	case WM_CLOSE:
		::ShowWindow(hwnd,SW_MINIMIZE);
		return 0;
	case WM_COMMAND: {
		sConnection_base* sc = (sConnection_base*)GetProp(hwnd , "sConn*");
		if (!sc) return 0;
		switch (LOWORD(wParam)) {
			case IDOK:
				if (sc->stage == esFinished) {
					sc->flags.closed = 1;
				} else if (!sc->flags.nocancel)
					if (sc->stage != esOperating || MessageBox(hwnd , "Na pewno chcesz przerwa transfer?" , "kTransfer" , MB_YESNO | MB_ICONQUESTION)==IDYES)
					sc->Cancel();
				return TRUE;
			case IDRETRY:
				if (sc->stage == esFinished && sc->operation == eoSending && sc->direction == edOutgoing)
					sc->Retry();
				return TRUE;
			case IDB_OPEN:
				ShellExecute(0 , "Open" , sc->filename.c_str() , "" , "" , SW_SHOW);
				sc->flags.closed = 1;
				return 1;
			case IDB_OPENDIR:
				if (sc->filename.find('\\')) {
					ShellExecute(0 , "Open" , sc->filename.substr(0 , sc->filename.find_last_of('\\')).c_str() , "" , "" , SW_SHOW);
					sc->flags.closed = 1;
				}
				return 1;
			case IDB_SAVEAS: {
				OPENFILENAME of;
				memset(&of , 0 , sizeof(of));
				char tbuff [500];
				char tname [MAX_PATH] = {0};
				strcpy(tname , sc->filename.c_str());
				sprintf(tbuff , "Gdzie zapisa plik %s?" , tname);
				of.lpstrTitle = tbuff;
				of.hwndOwner = sc->wnd;
				of.lStructSize = OPENFILENAME_SIZE_VERSION_400;
				char * ext = strrchr(tname , '.');
				char extBuff [50];
				if (ext) {
					_snprintf(extBuff , 50 , "Pliki *%s\0*%s\0" , ext , ext);
					of.lpstrFilter="*.*\0*.*\0";
				} else
					of.lpstrFilter="*.*\0*.*\0";
				of.lpstrFile=tname;
				of.nMaxFile=MAX_PATH;
			//  of.nFilterIndex=1;
				of.Flags=OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR | OFN_EXPLORER;
				of.lpstrDefExt="";
				if (GetSaveFileName(&of)) {
					unlink(tname);// kasujemy jakby co
					if (!_access(tname , 0) || rename(sc->filename.c_str() , tname)) {
						KTMessage("Nie mogem zapisa pliku!" , true , KNotify::sIMessage_notify::tError);
					}
					sc->filename = tname;
					sc->flags.closed = 1;
				}
				return 1;}
		}

		break;}
	default:
		return 0;
	}
	return 0;
}
