/*
Oryginalny kod: Piotr Pawluczuk / piopawlu.prv.pl
Zmiany od wersji 2.0: Rafa Lindemann / www.stamina.eu.org
*/

#include "stdafx.h"

// exporty biblioteki libgaduw32
#pragma comment(lib , "../../__output/libgadu.lib")

//////////////////////////////////////
//GLOBALS
//////////////////////////////////////
HINSTANCE hInst = NULL;
FILE* flog = NULL;
UINT  GGuin = 0;
struct activeNetworks {
	static bool gg , kLAN;
	static isActive() {return gg || kLAN;}
}; // aktywne sieci
bool activeNetworks::gg = false;
bool activeNetworks::kLAN = false;


int __stdcall DllMain(HINSTANCE hinstDLL, unsigned long fdwReason, void * lpvReserved)
{
	hInst = hinstDLL;
	return true;
}

int Init() {
	InitializeCriticalSection(&CSslots);
    return 1;
}

int DeInit() {
  /* Do usuwania rwnie...
  */
	DeleteCriticalSection(&CSslots);
  return 1;
}

bool kNotifyEnabled=false;
void KTMessage(string msg , bool mustSee , int msgType) {
	IMLOG(msg.c_str());

	if (kNotifyEnabled) {
		KNotify::sIMessage_notify n(msg.c_str());
		n._msgType = msgType;
		if (mustSee) {
			n._timeToLive = -1;
		}
		if (msgType == KNotify::sIMessage_notify::tInform) {
			n._icoID = UIIcon(IT_MESSAGE , NET_NONE , MT_FILE , 0);
		}
		Ctrl->IMessage(&n);
	} else {
		if (mustSee) {
			MessageBox(0 , msg.c_str() , "kTransfer" , MB_ICONERROR);
		}
	}
}

void SetKTStatus(string msg) {
	UIActionSetText(sUIAction(kTransfer::Act::gCfg , kTransfer::Act::plugStatus) , msg.c_str());
}
void UpdateKTStatus() {
	/* Jeeli nie jest to wtek interfejsu, zmieniamy wtek przy pomocy API Konnekta
	Wszystko dlatego, bo UI czasem moe by zablokowane i bez sensu, eby transfery
	na nie miay czeka...
	*/
	if (Ctrl->Is_TUS(0)) {
		IMessageDirect(kTransfer::IM::updateStatus , Ctrl->ID() , 0 , 0);
		return;
	}
	char ibuff [10];
	string msg = "kTransfer jest ";
	if (!hMainThread || usedPort == -1) {
		msg += "nieaktywny.";
	} else {
		msg += "aktywny.\r\n";
		msg += "  port = ";
		msg += itoa(usedPort , ibuff , 10);
		msg += ", pocze = ";
		msg += itoa(connectionsCount , ibuff , 10);
		msg += ", przychodzcych = ";
		msg += itoa(incomingCount , ibuff , 10);
	}
	SetKTStatus(msg);
}



int ISetCols()
{
	SetColumn(DTCFG,Cfg::remoteIP,DT_CT_STR,"" , "kT/remoteIP");
	SetColumn(DTCFG,Cfg::remotePort,DT_CT_INT,1550 , "kT/remotePort");

	SetColumn(DTCFG,Cfg::localIP,DT_CT_STR,"" , "kT/localIP");
	SetColumn(DTCFG,Cfg::localPort,DT_CT_PCHAR,"1550-1560" , "kT/localPort");

//	CFGSETCOL(CFG_USEKLAN,DT_CT_INT,0);

	SetColumn(DTCFG,Cfg::autoDropDir,DT_CT_STR,"Download\\%KonnektUser%" , "kT/autoDropDir");
	SetColumn(DTCFG,Cfg::autoResume,DT_CT_INT,0 , "kT/autoResume");
	SetColumn(DTCFG,Cfg::autoAccept,DT_CT_INT,Cfg::aaFromAllowed , "kT/autoAccept");

	SetColumn(DTCFG,Cfg::behindNAT,DT_CT_INT,0 , "kT/behindNAT");
	SetColumn(DTCFG,Cfg::autoDetect,DT_CT_INT,1 , "kT/autoDetect");
	SetColumn(DTCFG,Cfg::portForwarding,DT_CT_INT,0 , "kT/portForwarding");

	//CFGSETCOL(Cfg::exWindow , DT_CT_INT , 1);
	SetColumn(DTCFG,Cfg::asMessage , DT_CT_INT , 1 , "kT/asMessage");
	SetColumn(DTCFG,Cfg::notifyOnCompletion , DT_CT_INT , 1 , "kT/notifyOnCompletion");
	SetColumn(DTCFG,Cfg::showOnConnection , DT_CT_INT , 0 , "kT/showOnConnection");
	SetColumn(DTCFG,Cfg::closeWindowDown , DT_CT_INT , 0 , "kT/closeWindowDown");
	SetColumn(DTCFG,Cfg::closeWindowUp , DT_CT_INT , 0 , "kT/closeWindowUp");
	SetColumn(DTCFG,Cfg::saveToHistory , DT_CT_INT , 1 , "kT/saveToHistory");
	SetColumn(DTCFG,Cfg::slotsMax , DT_CT_INT , 10 , "kT/slotsMax");
	SetColumn(DTCFG,Cfg::dirReceive , DT_CT_PCHAR , "" , "kT/dirReceive");
	SetColumn(DTCFG,Cfg::dirSend , DT_CT_PCHAR , "" , "kT/dirSend");
	SetColumn(DTCFG,Cfg::minDriveSpace , DT_CT_INT , 50 , "kT/minDriveSpace");

	SetColumn(DTCFG,Cfg::sendToInvisible,DT_CT_INT,0 , "kT/sendToInvisible");

	SetColumn(DTCNT,Cnt::autoAccept,DT_CT_INT,0 , "kT/autoAccept");
	SetColumn(DTCNT,Cnt::autoDropDir,DT_CT_STR , (int)"" , "kT/autoDropDir");

	return 1;
}

int IPrepare()
{

	int kID = ICMessage(IMC_FINDPLUG_BYSIG , (int)"K.NOTIFY");
	kID = ICMessage(IMC_PLUGID_POS , kID);
	if (kID > 0 && ICMessage(IMC_PLUG_VERSION , kID) >= VERSION_TO_NUM(0 , 4 , 0 , 0))
		kNotifyEnabled = true;

	ICMessage(IMI_ICONRES,IDI_P2P,IDI_ICON1);
	ICMessage(IMI_ICONRES,IDI_P2P + 1,IDI_ICON2);


	//INT group = ICMessage(IMI_GETPLUGINSGROUP);
	//UIActionAdd(group,IMIA_P2P_BUTTON,0,"kTransfer...",IDI_P2P);

	INT pos = UIActionGetPos(IMIG_CNT,IMIA_CNT_SEP);

	UIActionInsert(IMIG_CNT,Act::sendFile,pos,ACTR_INIT,"Wylij plik",UIIcon(IT_MESSAGE,0,MT_FILE,0));//popup menu
	UIActionInsert(IMIG_CNT,Act::receiveFile,pos,ACTR_INIT,"Odbierz plik",UIIcon(IT_MESSAGE,0,MT_FILE,0));//popup menu
	UIActionInsert(IMIG_MSGTB,Act::sendFile,-1,ACTR_INIT | ACTR_SHOW,"Wylij plik",UIIcon(IT_MESSAGE,0,MT_FILE,0));//message wnd

	UIGroupAdd(IMIG_CFG_PLUGS,Act::gCfg,0,"kTransfer",IDI_P2P); {

		UIActionAdd(Act::gCfg , 0 , ACTT_GROUP , ""); {
			UIActionAdd(Act::gCfg , 0 , ACTT_IMAGE | ACTSC_INLINE , "reg://IML16/130000.ico" , 0 , 16 , 16);
			UIActionAdd(Act::gCfg , 0 , ACTT_INFO , 
				"Przesyanie plikw w sieciach GG i kLAN."
				"\r\nWtyczka wcza si gdy aktywne jest poczenie z ktr z sieci."
				"\r\n(c)2003 Rafa Lindemann , Piotr Pawluczuk."
				, 0 , 0 , 40);
			UIActionAdd(Act::gCfg , Act::plugStatus , ACTT_INFO | ACTSC_BOLD , 
				"Wtyczka jest zatrzymana" , 0 , 0 , 32);
		} UIActionAdd(Act::gCfg , 0 , ACTT_GROUPEND);


//		UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUP , "Ustawienia p2p"); {
		UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUP , "Lokalne IP:PORT");{
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK|ACTR_STATUS,"Autodetekcja",Cfg::autoDetect ,0,0,16,0);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT|ACTSC_INLINE,0,Cfg::localIP ,0,0,80);
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT|ACTSC_INLINE," : " , 0 , 0 , 0 , 10);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT,"" CFGTIP "Moesz poda przedzia w postaci od-do",Cfg::localPort ,0,0,80,0);
		UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUPEND);}
		UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUP , "Przekierowanie"); { 
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK|ACTR_STATUS,"Jestem za NAT'em (IP prywatne)" CFGTIP "take gdy masz przekierowanie",Cfg::behindNAT);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK|ACTR_STATUS,"Posiadam przekierowany port (forwardowanie)",Cfg::portForwarding);
	
			UIActionAdd(Act::gCfg,0,ACTT_COMMENT,"IP:PORT [tylko gdy masz forwardowanie]");

			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT|ACTSC_INLINE,0,Cfg::remoteIP ,0,0,80);
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT|ACTSC_INLINE," : " , 0 , 0 , 0 , 10);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT|ACTSC_INT,0,Cfg::remotePort ,0,0,40,0);
		} UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUPEND);
//		} UIActionCfgAdd(Act::gCfg , 0 , ACTT_GROUPEND);


		UIActionCfgAdd(Act::gCfg,0,ACTT_GROUP,"Opcje"); {
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Pozwalaj na przesyanie do osb niewidocznych",Cfg::sendToInvisible);
	//		UIActionCfgAdd(Act::gCfg,0,ACTT_CHECK,"Rozszerzone okno pobierania",Cfg::exWindow);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Informuj na licie kontaktw o nadejciu pliku",Cfg::asMessage);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Pokazuj okno ju podczas nawizywania poczenia",Cfg::showOnConnection);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Informuj o zakoczeniu transferu przez kNotify",Cfg::notifyOnCompletion);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Zapisuj do historii",Cfg::saveToHistory);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_CHECK,"Pozwalaj na kontynuacj (dociganie) nieodebranych plikw" ,Cfg::autoResume);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT|ACTSC_INLINE|ACTSC_INT,0,Cfg::slotsMax ,0,0,40,0);
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT,"- maksymalna liczba pocze przychodzcych");
		}UIActionCfgAdd(Act::gCfg,0,ACTT_GROUPEND);

		UIActionCfgAdd(Act::gCfg,0,ACTT_GROUP,"Pobieranie automatyczne"); {
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_COMBO | ACTSCOMBO_LIST | ACTSCOMBO_NOICON | ACTSC_INLINE ,"Zawsze pytaj" CFGVALUE "0" "\n" "Tylko od zaznaczonych" CFGVALUE "4" "\n" "Od wszystkich" CFGVALUE "8"  ,Cfg::autoAccept , 0 , 0 , 150);
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT ," - Automatyczne pobieranie");
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT,"Katalog skadowania plikw (pena cieka):" CFGTIP "%konnektProfile% - katalog profilu");
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_DIR ,0,Cfg::autoDropDir);
			UIActionCfgAdd(Act::gCfg,IMIB_CFG,ACTT_EDIT | ACTSC_INT | ACTSC_INLINE ,0  ,Cfg::minDriveSpace , 0 , 0 , 50);
			UIActionCfgAdd(Act::gCfg,0,ACTT_COMMENT ," - Limit wolnego miejsca na dysku w MB");
		} UIActionCfgAdd(Act::gCfg,0,ACTT_GROUPEND);
		UIActionCfgAdd(Act::gCfg,0,ACTT_GROUP,"Kontrola"); {
			UIActionCfgAdd(Act::gCfg, Act::start ,ACTT_BUTTON | ACTSC_INLINE ,"Uruchom");
			UIActionCfgAdd(Act::gCfg, Act::stop ,ACTT_BUTTON | ACTSC_INLINE ,"Zatrzymaj");
			UIActionCfgAdd(Act::gCfg, Act::restart ,ACTT_BUTTON ,"Zrestartuj");
		} UIActionCfgAdd(Act::gCfg,0,ACTT_GROUPEND);

		UIGroupAdd(IMIG_NFO,Act::gInfo, ACTR_INIT,"kTransfer",IDI_P2P); {
			UIActionCfgAdd(Act::gInfo,0,ACTT_GROUP,"Pobieranie automatyczne"); {
				UIActionCfgAdd(Act::gInfo,IMIB_CNT,ACTT_CHECK , "Akceptuj wszystko od tego kontaktu" CFGTIP "Musisz ustawi odpowiedni opcj w konfiguracji!" ,Cnt::autoAccept);
				UIActionCfgAdd(Act::gInfo,0,ACTT_COMMENT,"Katalog skadowania plikw (pena scieka):" CFGTIP ".\\ - katalog oglny skadowania plikw");
				UIActionCfgAdd(Act::gInfo,IMIB_CNT,ACTT_DIR ,0,Cnt::autoDropDir);
			} UIActionCfgAdd(Act::gInfo,0,ACTT_GROUPEND);
		}
		
	}
	return 1;
}

void DoSendOut(int cntid)
{
	int port = GETCNTI(cntid,CNT_PORT);
	string ip = GETCNTC(cntid,CNT_HOST);
	string name = GETCNTC(cntid,CNT_DISPLAY);
	string uin = GETCNTC(cntid,CNT_UID);
	int net = GETCNTI(cntid , CNT_NET);

	// Podstawowe sprawdzenia...
/*	if(strtoul(uin,NULL,10) == my_uin) {
		KTMessage("Nie moesz wykona poczenia do samego siebie!",true,1);
		return;
	}
*/
	if(!IsRunning()) {
		KTMessage("kTransfer nie jest uruchomiony!\nPocz si ponownie!",true,1);
		return;
	}
	if(port == 0) {
		KTMessage("Uytkownik nie ma ci w kontaktach lub ma wyczon opcj p2p!",true,1);
		return;
	} else if(port == 1) {
		if(GETINT(Cfg::behindNAT)) {
			if(!GETINT(Cfg::portForwarding)) {
				KTMessage("adna ze stron nie ma moliwoci poczenia!",true,1);
				return;
			}
		}
	}


	// Skoro ju wszystko jest sprawdzone, moemy szykowa si do wysyki...
	// Mona wybiera po kilka plikw do wysania...
    OPENFILENAME of;
    memset(&of , 0 , sizeof(of));
	string dirSend = GETSTR(Cfg::dirSend);
	of.lpstrInitialDir = dirSend.c_str();
    of.lpstrTitle = "Wybierz pliki do wysania";
	of.hwndOwner = (HWND)UIGroupHandle(sUIAction(0 , IMIG_MAINWND));
    of.lStructSize=OPENFILENAME_SIZE_VERSION_400;
	of.lpstrFilter="*.*\0*.*\0";
	char fileNames [10000] = {0};
	of.lpstrFile=fileNames;
	of.nMaxFile=10000;
//  of.nFilterIndex=1;
	of.Flags=OFN_PATHMUSTEXIST | OFN_NOCHANGEDIR | OFN_ALLOWMULTISELECT | OFN_EXPLORER;
	of.lpstrDefExt="";
	sConnection_base* prevSC = 0;
	sConnection_base* firstSC = 0;
	if (GetOpenFileName(&of)) {
		of.lpstrFile[of.nFileOffset-1] = 0;
		const char * dir = of.lpstrFile;
		const char * path = of.lpstrFile + of.nFileOffset;
		IMLOG("Generuj acuch pocze (host=%s:%d, name=%s, dir=%s)" , ip.c_str(),port,name.c_str(),dir);
		while (*path) {
			sConnection_base* sc;
			if (net != NET_GG || port>2) 
				sc = new sConnection;
			else 
				sc = new sConnection_request;
			if(!sc)	{
				ReportError("Brak wystarczajcej iloci pamici!",true);
				return;
			}
			// W zalenoci od typu poczenia odpowiednio si zachowujemy...
			if (net != NET_GG || port > 2) {
				sConnection * s = static_cast<sConnection *>(sc);
				hostent * he = gethostbyname(ip.c_str());
                if (he) {
                    memcpy(&s->address , he->h_addr , 4);
                }
				s->port = port;
				s->direction = sConnection::edOutgoing;
				s->operation = sConnection::eoSending;
				s->UID = uin;
				s->net = net;
			} else {
			}
			sc->cntID = cntid;
			sc->filename = dir + string("\\") + path;
			if (!firstSC) firstSC = sc;
			if (prevSC) prevSC->next = sc; // czymy je w acuch...
			path += strlen(path)+1;
			prevSC = sc;
		}
		// Startujemy pierwszy z acucha...
		if (firstSC) firstSC->Start();
		SETSTR(Cfg::dirSend , dir);

	}


}

ActionProc(sUIActionNotify_base * anBase)
{
  sUIActionNotify_2params * an = (anBase->s_size>=sizeof(sUIActionNotify_2params))?static_cast<sUIActionNotify_2params*>(anBase):0;

	switch (anBase->act.id)
	{
	case (Cfg::behindNAT | IMIB_CFG):
//		if (anBase->code == ACTN_ACTION || anBase->code == ACTN_STATUS)
//			UIActionSetStatus(sUIAction(Act::gCfg , IMIB_CFG | Cfg::portForwarding) , (*UIActionCfgGetValue(anBase->act,0,0)=='1') ? 0 : -1 , ACTS_DISABLED);
		break;
	case (Cfg::portForwarding | IMIB_CFG):
		if (anBase->code == ACTN_ACTION || anBase->code == ACTN_STATUS) {
			bool on = *UIActionCfgGetValue(anBase->act,0,0)=='1';
			UIActionSetStatus(sUIAction(Act::gCfg , IMIB_CFG | Cfg::remotePort) , (on) ? 0 : -1 , ACTS_DISABLED);
			UIActionSetStatus(sUIAction(Act::gCfg , IMIB_CFG | Cfg::remoteIP) , (on) ? 0 : -1 , ACTS_DISABLED);
		}
		break;
	case (Cfg::autoDetect | IMIB_CFG):
		if (anBase->code == ACTN_ACTION || anBase->code == ACTN_STATUS)
			UIActionSetStatus(sUIAction(Act::gCfg , IMIB_CFG | Cfg::localIP) , (*UIActionCfgGetValue(anBase->act,0,0)=='1') ? -1 : 0 , ACTS_DISABLED);
		break;

	case Act::gInfo:
		if (anBase->code == ACTN_CREATE)
			UIActionSetStatus(anBase->act , Ctrl->DTgetPos(DTCNT , anBase->act.cnt)==0 ? -1 : 0 , ACTS_HIDDEN);
		break;

	case Act::sendFile:
	{
		if (anBase->code == ACTN_SHOW || anBase->code == ACTN_CREATE)
		{
			int status = GETCNTI(an->act.cnt,CNT_STATUS);
			int net = GETCNTI(an->act.cnt , CNT_NET);
			bool netok = (net == NET_GG) || (net == kLAN::net);
			UIActionSetStatus(anBase->act , netok ? 0 : -1 , ACTS_HIDDEN);
		}
		else if(anBase->code == ACTN_ACTION)
		{
			DoSendOut(an->act.cnt);
		}
		break;
	}

	case Act::receiveFile:
	{
		if(anBase->code == ACTN_ACTION) 
		{
			sMESSAGESELECT ms;
			ms.net = GETCNTI(anBase->act.cnt , CNT_NET);
            ms.uid = (char*)GETCNTC(anBase->act.cnt , CNT_UID);
            ms.type = MT_FILE;
            ms.woflag = MF_SEND;
			cMessage m;
			if (ICMessage(IMC_MESSAGEGET , (int)&ms , (int)&m)) {
				HWND wnd = (HWND)atoi(GetExtParam(m.ext , "KT_HWND_TO_OPEN").c_str());
				// Znajdujemy slot'a...
				for (slots_it i = slots.begin(); i != slots.end(); i++) {
					if ((*i)->wnd == wnd) {
						(*i)->ShowWindow(true);
						break;
					}
				}
				ms.id = m.id;
				ICMessage(IMC_MESSAGEREMOVE , (int)&ms);
			}
		} 
		else if (anBase->code == ACTN_CREATE  || anBase->code == ACTN_DEFAULT)
		{
			// tylko przy pojedynczych kontaktach...
			if (anBase->act.cnt == -1)  {
				if (anBase->code == ACTN_CREATE) 
					UIActionSetStatus(anBase->act , -1 , ACTS_HIDDEN); 
				else 
					return false;
			}
			// Sprawdzamy, czy w kolejce siedzi taka wiadomo...
            sMESSAGEWAITING mw;
			mw.net = GETCNTI(anBase->act.cnt , CNT_NET);
            mw.uid = (char*)GETCNTC(anBase->act.cnt , CNT_UID);
            mw.type = MT_FILE;
            mw.woflag = MF_SEND;
			bool waiting = IMessage(IMC_MESSAGEWAITING ,0,0,(int)&mw);
			if (anBase->code == ACTN_DEFAULT)
				return waiting;
			else
				UIActionSetStatus(anBase->act ,	waiting? 0 : -1 , ACTS_HIDDEN);

		}
		break;
	}
	case Act::start: {
		ACTIONONLY(anBase);
		if(!StartListen())
		{
			KTMessage("Bd uruchamiania wtku!" , true , 2);
		}
		break;}
	case Act::stop: {
		ACTIONONLY(anBase);
		if(!StopListen(true))
		{
			KTMessage("Bd uruchamiania wtku!" , true , 2);
		}
		break;}
	case Act::restart: {
		ACTIONONLY(anBase);
		StopListen(true);
		StartListen();
		break;}
	default:
		break;
	}
	return 0;
}

int GaduGaduProc(sIMessage_GGEvent* me)
{
	static CHAR buffer[256]={0};

	switch(me->eventType)
	{
	case GGER_LOGIN:
		{
			if(!StartListen())
			{
				KTMessage("Bd uruchamiania wtku!" , false , 2);
			}
			activeNetworks::gg = true;

			gg_login_params* lp = (gg_login_params*)me->data.login_params;

			GGuin = lp->uin;
//			port = GETINT(Cfg::localPort);
			//SETINT(CFG_GG_DCCPORT,port);
			gg_dcc_port = usedPort;


			if(!GETINT(Cfg::autoDetect))
			{
				//GETSTR(Cfg::localIP,buffer,256);
				//SETSTR(CFG_GG_DCC,buffer);
				gg_dcc_ip = inet_addr(GETSTR(Cfg::localIP));

			}
			else
			{
				//SETSTR(CFG_GG_DCC,"255.255.255.255");
				gg_dcc_ip = -1;
			}

			if(GETINT(Cfg::portForwarding))
			{
				GETSTR(Cfg::remoteIP,buffer,256);

				lp->external_addr = (UINT)inet_addr(buffer);
				lp->external_port = (UINT)GETINT(Cfg::remotePort);
			}

			break;
		}
	case GGER_LOGOUT:
		activeNetworks::gg = false;
		if (hMainThread && slots.size())
			KTMessage("Poczenie z serwerem zostao zerwane. Wszystkie transfery dziaaj dalej...");
		break;
	case GGER_BEFORELOGOUT: // LogOut na yczenie...
		{
			activeNetworks::gg = false;
			if(!activeNetworks::isActive() && !StopListen(true))
			{
				KTMessage("Bd zatrzymywania wtku!" , false , 2);
			}
			break;
		}
	case GGER_EVENT:
	{
		gg_event* gge = (gg_event*)me->data.event;

		if(gge->type == 1 && gge->event.msg.msgclass == 0x0010)//Message, TCPC
		{
			char suid[32]={0};
			LONG uid = gge->event.msg.sender;
			INT cntid = 0;

			sprintf(suid,"%d",gge->event.msg.sender);
			cntid = ICMessage(IMC_CNT_FIND, NET_GG, (int)suid);
			IMLOG("Otrzymaem danie poczenia zwrotnego od %d / %d" , gge->event.msg.sender , cntid);
			if(cntid<0)
			{
				break;
			}

			INT port = GETCNTI(cntid,CNT_PORT);
			const char* ip = GETCNTC(cntid,CNT_HOST);
			const char* name = GETCNTC(cntid,CNT_DISPLAY);

			if(port!=0 && port!=2 && inet_addr(ip)!=INADDR_NONE)
			{
				sConnection* sc = new sConnection;
				if(!sc)
				{
					ReportError("Brak wystarczajcej iloci pamici!",true);
					return FALSE;
				}
				hostent * he = gethostbyname(ip);
                if (he) {
                    memcpy(&sc->address , he->h_addr , 4);
                }
				sc->port = port & 0xffff;
				sc->direction = sConnection::edOutgoing;
				sc->operation = sConnection::eoReceiving;
				char uinBuff [10];
				sc->UID = itoa(gge->event.msg.sender , uinBuff , 10);
				sc->net = NET_GG;
				sc->cntID = cntid;
				sc->Start();
			}
		}
		break;
	}
	default:
		break;
	}
	return 0;
}

void kLAN_sendDCC(const string & to) {
	CStdString IP;
	if (GETINT(kTransfer::Cfg::autoDetect)) {
		char buff [250];
//			if (!gethostname(buff , 250))
		DWORD read = 250;
		GetComputerName(buff , &read);
		IP = buff;
	} else {
		IP = GETSTR(kTransfer::Cfg::localIP);
	}
	if (IP.empty()) return;
	IP+=char(0);
	char buff [10];
	IP +=_itoa(usedPort , buff , 10);
	// wysyamy do wszystkich komend - KTRANSFER_DCC ip port
	Ctrl->IMessage(&kLAN::IM::SendCommand(to , "KTRANSFER_DCC" , IP));
}

int kLAN_Event(kLAN::IM::Event* e) {
	// Zaraz po poczeniu trzeba wysa innym klientom nasze IP i PORT na ktrym suchamy...
	if (e->_event == kLAN::IM::eventStarted) {
		activeNetworks::kLAN = true;
		if(!StartListen())
		{
			KTMessage("Bd uruchamiania wtku!" , false , 2);
		}
		kLAN_sendDCC("*");
	} else if (e->_event == kLAN::IM::eventFinished) {
		activeNetworks::kLAN = false;
		if(!activeNetworks::isActive() && !StopListen(true))
		{
			KTMessage("Bd zatrzymywania wtku!" , false , 2);
		}
	}
	return 0;
}

int kLAN_EventReceivingCommand(kLAN::IM::EventReceivingCommand* e) {
	if (e->_params[kLAN::MS_COMM] == "KTRANSFER_DCC") {
		if (e->_params.size() < kLAN::MS_PAR + 2) 
			throw "Too short";
		SETCNTC(e->_cnt , CNT_HOST , e->_params[kLAN::MS_PAR + 0].c_str());
		SETCNTC(e->_cnt , CNT_PORT , e->_params[kLAN::MS_PAR + 1].c_str());
		ICMessage(IMI_REFRESH_CNT , e->_cnt);
	} else if (e->_params[kLAN::MS_COMM] == "GETSTATUS") {
		kLAN_sendDCC(e->_params[kLAN::MS_FROM]);
	}
	return 0;
}



int IStart()
{
	IMessage(IM_GG_REGISTERHANDLER,NET_GG,IMT_PROTOCOL,GGER_BEFORELOGIN|GGER_LOGIN|GGER_LOGOUT|GGER_EVENT|GGER_BEFORELOGOUT);
	Ctrl->IMessage(&kLAN::IM::RegisterHandler(kLAN::IM::eventStarted | kLAN::IM::eventReceiving | kLAN::IM::eventFinished));
	ThreadInit();
	UpdateKTStatus();
	return 1;
}

int IEnd()
{
	StopListen(false);
	ThreadDeInit();
	return 1;
}

int __stdcall IMessageProc(sIMessage_base * msgBase)
{
 sIMessage_2params * msg = (msgBase->s_size>=sizeof(sIMessage_2params))?static_cast<sIMessage_2params*>(msgBase):0;

 switch (msgBase->id)
 {
    case IM_PLUG_NET:		return NET_P2P;
	case IM_PLUG_TYPE:		return IMT_UI | IMT_CONTACT | IMT_MESSAGE | IMT_ALLMESSAGES | IMT_CONFIG; // Ta wtyczka obsuguje UI, kontakty i Config...
    case IM_PLUG_VERSION:	return 0; // 
    case IM_PLUG_SDKVERSION:return KONNEKT_SDK_V;  // Ta linijka jest wymagana!
    case IM_PLUG_SIG:		return (int)"kTransfer"; // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    case IM_PLUG_CORE_V:	return (int)"W98"; // Wymagana wersja rdzenia
    case IM_PLUG_UI_V:		return 0; // Wymagana wersja UI
    case IM_PLUG_NAME:		return (int)"kTransfer2"; // Pena nazwa wtyczki
    case IM_PLUG_NETNAME:	return 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    case IM_PLUG_INIT:		Plug_Init(msg->p1,msg->p2);return Init();
    case IM_PLUG_DEINIT:	Plug_Deinit(msg->p1,msg->p2);return DeInit();
    case IM_PLUG_PRIORITY:   return PLUGP_LOW - 8;
	case IM_ALLPLUGINSINITIALIZED: {
		// Sprawdzamy czy przypadkiem nie ma tam gdzie p2p...
		int id = ICMessage(IMC_FINDPLUG_BYSIG , (int)"p2p");
		if (id) {
			Ctrl->IMessage(&sIMessage_plugOut(id , "kTransfer nie moe pracowa rwnoczenie z p2p.dll" , sIMessage_plugOut::erNo , sIMessage_plugOut::euNowAndOnNextStart));
		}

		break;}
    case IM_SETCOLS:		return ISetCols();

    case IM_UI_PREPARE:		return IPrepare();
    case IM_START:			return IStart();
    case IM_END:			return IEnd();
	case IM_GG_EVENT:
		{
			sIMessage_GGEvent * me = static_cast<sIMessage_GGEvent*>(msgBase);
			return GaduGaduProc(me);
		}
	case IM_UIACTION:		return ActionProc((sUIActionNotify_base*)msg->p1);

	case kSound::DOREGISTER: {
		kSound::SoundRegister(Ctrl , "fileReceived" , "Odebranie pliku" , kSound::flags::contacts);
		kSound::SoundRegister(Ctrl , "fileFinished" , "Zakoczone przesyanie" , kSound::flags::contacts);
		return 0;}
	case IM_MSG_RCV: {
		cMessage * m = reinterpret_cast<cMessage *>(msg->p1);
		if (m->type == MT_FILE && (m->flag & MF_NOSAVE)) {
			return IM_MSG_ok; // bdziemy go obsugiwa...
		}
		return 0;}
	case IM_CANTQUIT:
		return StopListen(true) == -1;
	case kLAN::IM::Event::__msgID:
		return kLAN_Event(static_cast<kLAN::IM::Event*>(msgBase));
	case kLAN::IM::EventReceivingCommand::__msgID:
		return kLAN_EventReceivingCommand(static_cast<kLAN::IM::EventReceivingCommand*>(msgBase));
	case kTransfer::IM::updateStatus:
		// Gdy wtek jest rny od wtku interfejsu, kolejkuje komunikat w wtku UI i pracuje dalej...
		// Wtek UI potem przetworzy komunikat i bez przeszkd wykonamy UpdateKTStatus().
		IMESSAGE_TS_NOWAIT(0);
		UpdateKTStatus();
		return 0;

 }

if (Ctrl) Ctrl->setError(IMERROR_NORESULT);
return 0;
}