#include "stdafx.h"

char fnbuffer[MAX_PATH + 1] = {0};
char fmbuffer[MAX_PATH * 10 + 1] = {0};

const char* GetFileName(BOOL open,LPSTR filter,const char* fname,const char** filename)
{
	OPENFILENAME ofn = {0};
	DWORD error = 0;

	ofn.lStructSize = sizeof(ofn);

	if(fname)strcpy(fnbuffer,fname);
	
	ofn.hwndOwner = NULL; 
	ofn.lpstrFile = fnbuffer; 
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrTitle = TEXT("Select File");
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrCustomFilter = NULL;
	ofn.lpstrFileTitle = NULL;
	ofn.lpstrDefExt = NULL;

	if(open)
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_EXPLORER;
	else
		ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT | OFN_EXPLORER;


	if(open && GetOpenFileName(&ofn)==IDOK)
	{
		if(filename)
		{
			*filename = fnbuffer + ofn.nFileOffset;
		}
		return fnbuffer;
	}
	else if(!open && GetSaveFileName(&ofn)==IDOK)
	{
		if(filename)
		{
			*filename = fnbuffer + ofn.nFileOffset;
		}
		return fnbuffer;
	}
	else
	{
		error = GetLastError();
		error = CommDlgExtendedError();
		return NULL;
	}
}

BOOL FileExists(const char* path,unsigned long *size,UINT64 *mod_date)
{
	WIN32_FIND_DATA fd;
	HANDLE hFindFile = FindFirstFile(path,&fd);

	if(hFindFile && hFindFile!=(HANDLE)-1 && fd.nFileSizeHigh == 0)
	{
		if(size)*size = fd.nFileSizeLow;
		if(mod_date)*mod_date = *((UINT64*)&fd.ftLastWriteTime);
		FindClose(hFindFile);
		return TRUE;
	}
	else
	{
		if(size)*size = 0;
		if(mod_date)*mod_date = NULL;
		return 0;
	}
}

BOOL DirExists(const char* path)
{
	WIN32_FIND_DATA fd;
	HANDLE hFindFile = FindFirstFile(path,&fd);

	if(hFindFile && hFindFile!=(HANDLE)-1 && (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
		return TRUE;
	else
		return 0;
}


int mkdirs(const char * path) {
  if (!*path) return 1;
  int r;
  r = 0;
  if (access(path , 0)) {
    char * st = strrchr((char*)path , '\\');
    if (!st) return 1;
    *st=0;
    r = mkdirs(path);
    *st='\\';
    if (_mkdir(path)) {
      return 1;
    }
  }
  return r;
}

